// DDK̃wb_[COɂĂ̂extern "C"Kv
extern "C"{
#include <ntddk.h>
#include <ntddkbd.h>
}

// zuւL[̃XLER[h
#define	SCAN_CAPS		(0x3a)
#define	SCAN_LEFTCTRL	(0x1d)
#define	SCAN_ESC		(0x01)
#define	SCAN_ZENHAN		(0x29)

// ʃfoCXEIuWFNgւ̃|C^ۑ邽߂̍\
// DEVICE_OBJECT\̂DeviceExtensiontB[hANZXł悤ɂ
struct DEVEXT
{
	PDEVICE_OBJECT pNextDevObj;
};

// free buildDbgPrint()菜悤ɂ
#if	DBG
#define	DbgPrint(x)	DbgPrint x
#else	//DBG
#define	DbgPrint(x)
#endif	//DBG

extern "C"
NTSTATUS DefaultHandler( IN PDEVICE_OBJECT pDevObj, IN PIRP pIrp)
{
	DbgPrint(( "keyswap: DefaultHandler\n"));
	IoSkipCurrentIrpStackLocation( pIrp);
	DEVEXT *pDevExt = (DEVEXT *)pDevObj->DeviceExtension;
	return IoCallDriver( pDevExt->pNextDevObj, pIrp);
}

extern "C"
NTSTATUS PowerHandler( IN PDEVICE_OBJECT pDevObj, IN PIRP pIrp)
{
	DbgPrint(( "keyswap: PowerHandler\n"));
	PoStartNextPowerIrp( pIrp);
	IoSkipCurrentIrpStackLocation( pIrp);
	DEVEXT *pDevExt = (DEVEXT *)pDevObj->DeviceExtension;
	return PoCallDriver( pDevExt->pNextDevObj, pIrp);
}

extern "C"
NTSTATUS PnPHandler( IN PDEVICE_OBJECT pDevObj, IN PIRP pIrp)
{
	DbgPrint(( "keyswap: PnPHandler\n"));
	DEVEXT *pDevExt = (DEVEXT *)pDevObj->DeviceExtension;
	PIO_STACK_LOCATION pIrpStack = IoGetCurrentIrpStackLocation( pIrp);
	
	IoSkipCurrentIrpStackLocation( pIrp);
	NTSTATUS status = IoCallDriver( pDevExt->pNextDevObj, pIrp);
	if( pIrpStack->MinorFunction == IRP_MN_REMOVE_DEVICE){
		IoDetachDevice( pDevExt->pNextDevObj); 
		IoDeleteDevice( pDevObj);
		status = STATUS_SUCCESS;
	}
	return status;
}

extern "C"
NTSTATUS AddDeviceHandler( IN PDRIVER_OBJECT pDrvObj,
							IN PDEVICE_OBJECT pNextDevObj)
{
	DbgPrint(( "keyswap: AddDeviceHandler\n"));
	PDEVICE_OBJECT pDevObj;
	NTSTATUS status = IoCreateDevice(
						pDrvObj, sizeof(DEVEXT),
						NULL, FILE_DEVICE_KEYBOARD, 0, FALSE, &pDevObj);
	
	if( !NT_SUCCESS(status) )	return status;
	RtlZeroMemory( pDevObj->DeviceExtension, sizeof(DEVEXT) );
	
	DEVEXT *pDevExt = (DEVEXT *)pDevObj->DeviceExtension;
	pDevExt->pNextDevObj = IoAttachDeviceToDeviceStack( pDevObj, pNextDevObj);
	
	pDevObj->Flags |= (DO_BUFFERED_IO | DO_POWER_PAGABLE);
	pDevObj->Flags &= ~DO_DEVICE_INITIALIZING;
	return status;
}

extern "C"
NTSTATUS ReadComplete( IN PDEVICE_OBJECT pDevObj, IN PIRP pIrp, IN PVOID pCtx)
{
	DbgPrint(( "keyswap: ReadComplete\n"));
	if( NT_SUCCESS( pIrp->IoStatus.Status) ){
		PKEYBOARD_INPUT_DATA pKID
			= (PKEYBOARD_INPUT_DATA)pIrp->AssociatedIrp.SystemBuffer;
		int keynum = pIrp->IoStatus.Information / sizeof(*pKID);
		for( int i=0; i<keynum; i++){
			DbgPrint(( "Scan: %04x, Flags: %04x",
						pKID[i].MakeCode, pKID[i].Flags));
			
			switch( pKID[i].MakeCode){
			case SCAN_CAPS:
				pKID[i].MakeCode = SCAN_LEFTCTRL;
				break;
				
			case SCAN_LEFTCTRL:
				pKID[i].MakeCode = SCAN_CAPS;
				break;
				
			case SCAN_ESC:
				pKID[i].MakeCode = SCAN_ZENHAN;
				break;
				
			case SCAN_ZENHAN:
				pKID[i].MakeCode = SCAN_ESC;
				break;
			}
		}
	}
	if( pIrp->PendingReturned)	IoMarkIrpPending( pIrp);
	return pIrp->IoStatus.Status;
}

extern "C"
NTSTATUS ReadHandler( IN PDEVICE_OBJECT pDevObj, IN PIRP pIrp)
{
	DbgPrint(( "keyswap: ReadHandler\n"));
	IoCopyCurrentIrpStackLocationToNext( pIrp);
	IoSetCompletionRoutine( pIrp, ReadComplete, pDevObj, TRUE, TRUE, TRUE);
	DEVEXT *pDevExt = (DEVEXT *)pDevObj->DeviceExtension;
	return IoCallDriver( pDevExt->pNextDevObj, pIrp);
}

extern "C"
NTSTATUS DriverEntry( IN PDRIVER_OBJECT pDrvObj, IN PUNICODE_STRING RegPath)
{
	DbgPrint(( "keyswap: DriverEntry\n"));
	for( int i=0; i<IRP_MJ_MAXIMUM_FUNCTION; i++){
		pDrvObj->MajorFunction[i] = DefaultHandler;
	}
	pDrvObj->MajorFunction[IRP_MJ_READ]  = ReadHandler;
	pDrvObj->MajorFunction[IRP_MJ_POWER] = PowerHandler;
	pDrvObj->MajorFunction[IRP_MJ_PNP]   = PnPHandler;
	pDrvObj->DriverExtension->AddDevice  = AddDeviceHandler;
	return STATUS_SUCCESS;
}
